#include <stdio.h>
#include <math.h>

#define FUNC(f) double (*f)(double, double) 


double func(double t, double y)
{
	return 4/(1+t*t);
}

int rk4_step(double t, double *y, double h, FUNC(f))
{
	double yk;
	double k1,k2,k3,k4;

	yk = *y;

	k1=h*f(t,yk);
	k2=h*f(t+0.5*h,yk+0.5*k1);
	k3=h*f(t+0.5*h,yk+0.5*k2);
	k4=h*f(t+h,yk+k3);

	*y = yk + 1.0/6.0*(k1+2*k2+2*k3+k4);
	
}



int main()
{
	int i;
	double y,t,h;
	const int n=1000;

	h=1.0/n;

	t=0;
	y=0;

	printf("%lf %lf\n",t,y);

	for(i=1;i<=n;i++)
	{
		rk4_step(t,&y,h,&func);

		t=i*h;
	
		printf("%.8lf %.8lf\n",t,y);	
	}

	return 0;
}
