#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#define N 4

double M[N][N+1];

double S[N][N];
double U[N];
double R[N];


void init_M(){
	int i,j;

	for(i=0;i<N;i++)
	{
		for(j=0;j<N+1;j++)
		{
			if(j<N) M[i][j]=S[i][j];
			else if(j==N) M[i][j]=R[i];
		}

	}

}

//prevedeme tridiagonalni system na trojuhelnikovy tvar
//
//
void convert_M(){
	int i,j;
	double MM;

	for(i=1;i<N;i++)
	{
		MM=M[i-1][i-1]/M[i][i-1];
		for(j=0;j<N+1;j++)
		{
			M[i][j]=-MM * M[i][j]+M[i-1][j];					
		}
	}//i-loop	
}



//zpetnou substituci resime novy system
// U_{N-1}=M_{N-1 N}/M_{N-1 N-1}
// for i=N-2 to 0 step -1
// 	U_i=(M_{i N} - Sum_{j=i+1}^{N-1}M_{ij}U_j)
// end for
void solve(){
	int i,j;

	U[N-1]=M[N-1][N]/M[N-1][N-1];
	for(i=N-2;i>=0;i--)
	{
		fprintf(stderr,"i=%d\n",i);
		U[i]=M[i][N];
		for(j=i+1;j<N;j++)
		{
			fprintf(stderr,"j= %d\n",j);
			U[i]=U[i]-U[j]*M[i][j];
		}
		U[i]=U[i]/M[i][i];
	}

}


void show_M(){
	int i,j;

	printf("M=\n");
	for(i=0;i<N;i++)
	{
		for(j=0;j<N+1;j++)
		{
			printf("%2.4lf ",M[i][j]);
		}
		printf("\n");
	}

}

void show_sol()
{
	int i;
	printf("Sol=\n");
	for(i=0;i<N;i++) printf("%.4lf\n",U[i]);
}

int main()
{
	S[0][0]=1.0;
	S[0][1]=2.0;
	S[0][2]=0.0;
	S[0][3]=0.0;

	S[1][0]=3.0;
	S[1][1]=4.0;
	S[1][2]=-1.0;
	S[1][3]=0.0;

	S[2][0]=0.0;
	S[2][1]=6.0;
	S[2][2]=-3.0;
	S[2][3]=4.0;

	S[3][0]=0.0;
	S[3][1]=0.0;
	S[3][2]=-5.0;
	S[3][3]=1.0;

	U[0]=3.1;
	U[1]=0.0;
	U[2]=5.0;
	U[3]=6.2;

	R[0]=11.0;
	R[1]=4.0;
	R[2]=-7.0;
	R[3]=2.2;

	init_M();

	show_M();
	
	convert_M();

	show_M();

	solve();

	show_sol();
	
	return 0;
}
